package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.DataEntity;

/**
 * 实体[DataSyncOut2] 数据对象
 */
@TableName(value = "T_SRFDATASYNCOUT2",resultMap = "DataSyncOut2ResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class DataSyncOut2 extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private DataEntity de;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String data;
    private String datakey;
    @TableId(value= "datasyncout2id",type=IdType.UUID)//指定主键生成策略
    private String datasyncout2id;
    private String datasyncout2name;
    private String deid;
    private String dename;
    private String error;
    @Dict(dictName = "ionicdemo_CodeList72CodeList")
    private Integer eventtype;
    private String filelist;
    private String logicdata;
    @Dict(dictName = "ionicdemo_DataSyncInAgentCodeList")
    private String syncagent;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[数据]
     *  @param data
     */
    public void setData(String data){
        if(StringUtils.isEmpty(data))
            data=null;
        this.data = data;
        this.set("datadirtyflag",true);
    }
    /**
     *  获取属性值[数据]
     */
    public String getData(){
        return this.data;
    }
    /**
     *  重置属性值[数据]
     */
    public void resetData(){
        this.set("datadirtyflag",false);
        this.data = null;
    }
    /**
     *  设置属性值[数据主键]
     *  @param datakey
     */
    public void setDatakey(String datakey){
        if(StringUtils.isEmpty(datakey))
            datakey=null;
        this.datakey = datakey;
        this.set("datakeydirtyflag",true);
    }
    /**
     *  获取属性值[数据主键]
     */
    public String getDatakey(){
        return this.datakey;
    }
    /**
     *  重置属性值[数据主键]
     */
    public void resetDatakey(){
        this.set("datakeydirtyflag",false);
        this.datakey = null;
    }
    /**
     *  设置属性值[数据同步发送队列2标识]
     *  @param datasyncout2id
     */
    public void setDatasyncout2id(String datasyncout2id){
        if(StringUtils.isEmpty(datasyncout2id))
            datasyncout2id=null;
        this.datasyncout2id = datasyncout2id;
        this.set("datasyncout2iddirtyflag",true);
    }
    /**
     *  获取属性值[数据同步发送队列2标识]
     */
    public String getDatasyncout2id(){
        return this.datasyncout2id;
    }
    /**
     *  重置属性值[数据同步发送队列2标识]
     */
    public void resetDatasyncout2id(){
        this.set("datasyncout2iddirtyflag",false);
        this.datasyncout2id = null;
    }
    /**
     *  设置属性值[数据同步发送队列2名称]
     *  @param datasyncout2name
     */
    public void setDatasyncout2name(String datasyncout2name){
        if(StringUtils.isEmpty(datasyncout2name))
            datasyncout2name=null;
        this.datasyncout2name = datasyncout2name;
        this.set("datasyncout2namedirtyflag",true);
    }
    /**
     *  获取属性值[数据同步发送队列2名称]
     */
    public String getDatasyncout2name(){
        return this.datasyncout2name;
    }
    /**
     *  重置属性值[数据同步发送队列2名称]
     */
    public void resetDatasyncout2name(){
        this.set("datasyncout2namedirtyflag",false);
        this.datasyncout2name = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param deid
     */
    public void setDeid(String deid){
        if(StringUtils.isEmpty(deid))
            deid=null;
        this.deid = deid;
        this.set("deiddirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDeid(){
        return this.deid;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDeid(){
        this.set("deiddirtyflag",false);
        this.deid = null;
    }
    /**
     *  设置属性值[数据实体]
     *  @param dename
     */
    public void setDename(String dename){
        if(StringUtils.isEmpty(dename))
            dename=null;
        this.dename = dename;
        this.set("denamedirtyflag",true);
    }
    /**
     *  获取属性值[数据实体]
     */
    public String getDename(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.dename)&&(!StringUtils.isEmpty(this.getDeid())) && this.getDe()!=null)
        {
            this.dename = this.getDe().getDename();
            this.set("denamedirtyflag",true);
        }
        return this.dename;
    }
    /**
     *  重置属性值[数据实体]
     */
    public void resetDename(){
        this.set("denamedirtyflag",false);
        this.dename = null;
    }
    /**
     *  设置属性值[同步错误信息]
     *  @param error
     */
    public void setError(String error){
        if(StringUtils.isEmpty(error))
            error=null;
        this.error = error;
        this.set("errordirtyflag",true);
    }
    /**
     *  获取属性值[同步错误信息]
     */
    public String getError(){
        return this.error;
    }
    /**
     *  重置属性值[同步错误信息]
     */
    public void resetError(){
        this.set("errordirtyflag",false);
        this.error = null;
    }
    /**
     *  设置属性值[事件类型]
     *  @param eventtype
     */
    public void setEventtype(Integer eventtype){
        this.eventtype = eventtype;
        this.set("eventtypedirtyflag",true);
    }
    /**
     *  获取属性值[事件类型]
     */
    public Integer getEventtype(){
        return this.eventtype;
    }
    /**
     *  重置属性值[事件类型]
     */
    public void resetEventtype(){
        this.set("eventtypedirtyflag",false);
        this.eventtype = null;
    }
    /**
     *  设置属性值[同步文件清单]
     *  @param filelist
     */
    public void setFilelist(String filelist){
        if(StringUtils.isEmpty(filelist))
            filelist=null;
        this.filelist = filelist;
        this.set("filelistdirtyflag",true);
    }
    /**
     *  获取属性值[同步文件清单]
     */
    public String getFilelist(){
        return this.filelist;
    }
    /**
     *  重置属性值[同步文件清单]
     */
    public void resetFilelist(){
        this.set("filelistdirtyflag",false);
        this.filelist = null;
    }
    /**
     *  设置属性值[逻辑数据]
     *  @param logicdata
     */
    public void setLogicdata(String logicdata){
        if(StringUtils.isEmpty(logicdata))
            logicdata=null;
        this.logicdata = logicdata;
        this.set("logicdatadirtyflag",true);
    }
    /**
     *  获取属性值[逻辑数据]
     */
    public String getLogicdata(){
        return this.logicdata;
    }
    /**
     *  重置属性值[逻辑数据]
     */
    public void resetLogicdata(){
        this.set("logicdatadirtyflag",false);
        this.logicdata = null;
    }
    /**
     *  设置属性值[数据输出代理]
     *  @param syncagent
     */
    public void setSyncagent(String syncagent){
        if(StringUtils.isEmpty(syncagent))
            syncagent=null;
        this.syncagent = syncagent;
        this.set("syncagentdirtyflag",true);
    }
    /**
     *  获取属性值[数据输出代理]
     */
    public String getSyncagent(){
        return this.syncagent;
    }
    /**
     *  重置属性值[数据输出代理]
     */
    public void resetSyncagent(){
        this.set("syncagentdirtyflag",false);
        this.syncagent = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[DataEntity]
     */
    public DataEntity getDe() {
        return de;
    }
    /**
     *  设置主实体关联数据[DataEntity]
     */
    public void setDe(DataEntity de) {
        this.de = de;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetData();
        resetDatakey();
        resetDatasyncout2id();
        resetDatasyncout2name();
        resetDeid();
        resetDename();
        resetError();
        resetEventtype();
        resetFilelist();
        resetLogicdata();
        resetSyncagent();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public DataSyncOut2 copyTo(DataSyncOut2 targetEntity)
	{
		BeanCopier copier=BeanCopier.create(DataSyncOut2.class, DataSyncOut2.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetDatasyncout2id();
		return targetEntity;
	}
}